--**v Control for player infos v**
PlayerCtr = Turbine.UI.Control();
PlayerCtr:SetParent( wTitanBar );
PlayerCtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
PlayerCtr:SetBackColor( Turbine.UI.Color( PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue ) );

--**v Player icon & infos on TitanBar v**
PlayerIcon = Turbine.UI.Control();
PlayerIcon:SetParent( PlayerCtr );
PlayerIcon:SetPosition( 5, 2 );
PlayerIcon:SetSize( 25, 25 );
PlayerIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	
PlayerIcon.MouseMove = function( sender, args )
	wTitanBar.MouseLeave( sender, args )
	sFromCtr = "PN";
	ShowToolTipWin( "PIcon" );
end

PlayerIcon.MouseLeave = function( sender, args )
	wTitanBar.MouseLeave( sender, args )
end

PlayerIcon.MouseClick = function( sender, args )
	PlayerName.MouseClick( sender, args )
end

PlayerLvl = Turbine.UI.Label();
PlayerLvl:SetParent( PlayerCtr );
PlayerLvl:SetPosition( PlayerIcon:GetLeft() + PlayerIcon:GetWidth(), 0 );
PlayerLvl:SetForeColor( white );
PlayerLvl:SetFontStyle( Turbine.UI.FontStyle.Outline );
PlayerLvl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
--PlayerLvl:SetBackColor( white ); -- Debug purpose
	
PlayerLvl.MouseMove = function( sender, args )
	wTitanBar.MouseLeave( sender, args )
	sFromCtr = "PN";
	ShowToolTipWin( "PLvl" );
end

PlayerLvl.MouseLeave = function( sender, args )
	wTitanBar.MouseLeave( sender, args )
end

PlayerLvl.MouseClick = function( sender, args )
	PlayerName.MouseClick( sender, args )
end

PlayerName = Turbine.UI.Label();
PlayerName:SetParent( PlayerCtr );
PlayerName:SetForeColor( white );
PlayerName:SetFontStyle( Turbine.UI.FontStyle.Outline );
PlayerName:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
--PlayerName:SetBackColor( white ); -- Debug purpose

PlayerName.MouseMove = function( sender, args )
	wTitanBar.MouseLeave( sender, args )
	sFromCtr = "PN";
	ShowToolTipWin( "PName" );
end

PlayerName.MouseLeave = function( sender, args )
	wTitanBar.MouseLeave( sender, args )
end

PlayerName.MouseClick = function( sender, args )
	wTitanBar.MouseClick( sender, args )
end
--**^