-- background.lua
-- Written by Habna


function frmBackground()
	wBackground = Turbine.UI.Lotro.Window();
	sFrom = sFromCtr;
	frmBG, SetToAll = true, true;
	--wBackground = Turbine.UI.Lotro.GoldWindow()
	
	local initHeight = 210;
	local initWidth = 400;
	local initLeft=(Turbine.UI.Display:GetWidth() - initWidth) / 2;
	local initTop=(Turbine.UI.Display:GetHeight() - initHeight) / 2;
	
	wBackground.Opacity = 1;
	wBackground:SetText( "Set back color" );
	wBackground:SetSize( initWidth, initHeight );
	wBackground:SetPosition( initLeft, initTop );
	wBackground:SetVisible( true );
	--wBackground:SetZOrder( 2 );
	wBackground:Activate();

	-- **v Check box - label v**
	local SetToAllCtr = Turbine.UI.Lotro.CheckBox();
	SetToAllCtr:SetParent( wBackground );
	SetToAllCtr:SetPosition( 23, wBackground:GetHeight() - 70 );
	SetToAllCtr:SetText( " Apply currently selected color to all control" );
	SetToAllCtr:SetSize( string.len(SetToAllCtr:GetText()) * 8, 30 );
	SetToAllCtr:SetVisible( true );
	--SetToAllCtr:SetEnabled( false );
	SetToAllCtr:SetChecked( false );
	SetToAllCtr:SetForeColor( rustedgold );
	-- **^

	-- **v Currently set color - label v**
	local CurSetColorLbl = Turbine.UI.Label();
	CurSetColorLbl:SetParent( wBackground );
	CurSetColorLbl:SetPosition( 308, 35 );
	CurSetColorLbl:SetSize( 75, 30 );
	CurSetColorLbl:SetText( "Currently set color" );
	CurSetColorLbl:SetVisible( true );
	CurSetColorLbl:SetForeColor( rustedgold );
	-- **^
	-- **v Currently Selected color - box v**
	curSelColorBorder = Turbine.UI.Label();
	curSelColorBorder:SetParent( wBackground );
	curSelColorBorder:SetSize( 73, 73 );
	curSelColorBorder:SetPosition( 305, 60 );
	curSelColorBorder:SetBackColor( white );

	curSelColor = Turbine.UI.Label();
	curSelColor:SetParent( curSelColorBorder );
	curSelColor:SetSize( 71, 71 );
	curSelColor:SetPosition( 1, 1 );
	
	if sFrom == nil then curSelAlpha = bcAlpha; curSelRed = bcRed; curSelGreen = bcGreen; curSelBlue = bcBlue; end
	if sFrom == "Money" then curSelAlpha = MbcAlpha; curSelRed = MbcRed; curSelGreen = MbcGreen; curSelBlue = MbcBlue; end
	if sFrom == "DP" then curSelAlpha = DPbcAlpha; curSelRed = DPbcRed; curSelGreen = DPbcGreen; curSelBlue = DPbcBlue; end
	if sFrom == "BI" then curSelAlpha = BbcAlpha; curSelRed = BbcRed; curSelGreen = BbcGreen; curSelBlue = BbcBlue; end
	if sFrom == "PN" then curSelAlpha = PIbcAlpha; curSelRed = PIbcRed; curSelGreen = PIbcGreen; curSelBlue = PIbcBlue; end

	if sFrom == "GT" then curSelAlpha = GTbcAlpha; curSelRed = GTbcRed; curSelGreen = GTbcGreen; curSelBlue = GTbcBlue; end

	curSelColor:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) );
	-- **^
	-- **v Save button v**
	local buttonSave = Turbine.UI.Lotro.Button();
	buttonSave:SetParent( wBackground );
	buttonSave:SetText( "Save color" );
	buttonSave:SetSize( string.len(buttonSave:GetText()) * 10, 15 ); --Auto size with text lenght
	buttonSave:SetPosition( wBackground:GetWidth() - buttonSave:GetWidth() - 15 , wBackground:GetHeight() - 34 );
	buttonSave:SetVisible( true );
	buttonSave:SetEnabled( false );

	buttonSave.Click = function( sender, args )
		SetToAll = SetToAllCtr:IsChecked();
		
		if SetToAll then
			bcAlpha, MbcAlpha, DPbcAlpha, BbcAlpha, PIbcAlpha, GTbcAlpha = curSelAlpha, curSelAlpha, curSelAlpha, curSelAlpha, curSelAlpha, curSelAlpha;
			bcRed, MbcRed, DPbcRed, BbcRed, PIbcRed, GTbcRed = curSelRed, curSelRed, curSelRed, curSelRed, curSelRed, curSelRed;
			bcGreen, MbcGreen, DPbcGreen, BbcGreen, PIbcGreen, GTbcGreen = curSelGreen, curSelGreen, curSelGreen, curSelGreen, curSelGreen, curSelGreen;
			bcBlue, MbcBlue, DPbcBlue, BbcBlue, PIbcBlue, GTbcBlue = curSelBlue, curSelBlue, curSelBlue, curSelBlue, curSelBlue, curSelBlue;
		else
			if sFrom == nil then bcAlpha = curSelAlpha; bcRed = curSelRed; bcGreen = curSelGreen; bcBlue = curSelBlue; end
			if sFrom == "Money" then MbcAlpha = curSelAlpha; MbcRed = curSelRed; MbcGreen = curSelGreen; MbcBlue = curSelBlue; end
			if sFrom == "DP" then DPbcAlpha = curSelAlpha; DPbcRed = curSelRed; DPbcGreen = curSelGreen; DPbcBlue = curSelBlue; end
			if sFrom == "BI" then BbcAlpha = curSelAlpha; BbcRed = curSelRed; BbcGreen = curSelGreen; BbcBlue = curSelBlue; end
			if sFrom == "PN" then PIbcAlpha = curSelAlpha; PIbcRed = curSelRed; PIbcGreen = curSelGreen; PIbcBlue = curSelBlue; end

			if sFrom == "GT" then GTbcAlpha = curSelAlpha; GTbcRed = curSelRed; GTbcGreen = curSelGreen; GTbcBlue = curSelBlue; end
		end

		ChangeColor();
		SaveSettings();
		buttonSave:SetEnabled( false );
	end
	-- **^
	-- Create alpha label and slider.
	local alphalabel = Turbine.UI.Label();
	alphalabel:SetParent( wBackground );
	alphalabel:SetText( "Alpha @ " .. ( curSelAlpha * 100 ) .. "%" );
	alphalabel:SetPosition( 40, 40 );
	alphalabel:SetSize( 242, 10 );
	alphalabel:SetBackColor( black );
	alphalabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	
	local alphaScrollBar = Turbine.UI.Lotro.ScrollBar();
	alphaScrollBar:SetParent( alphalabel );
	alphaScrollBar:SetPosition( 0, 0 );
	alphaScrollBar:SetSize( 242, 10 );
	alphaScrollBar:SetMinimum( 0 );
	alphaScrollBar:SetMaximum( 100 );
	alphaScrollBar:SetValue( curSelAlpha * 100);
	
	alphaScrollBar.ValueChanged = function(sender, args)
		curSelAlpha = alphaScrollBar:GetValue() / 100;
		alphalabel:SetText( "Alpha " .. ( curSelAlpha * 100 ) .. "%" );
		curSelColor:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) );
		ChangeColor();
		buttonSave:SetEnabled( true );
	end
	-- **^
	-- **v Default button v**
	local buttonDefault = Turbine.UI.Lotro.Button();
	buttonDefault:SetParent( wBackground );
	buttonDefault:SetPosition( 23, wBackground:GetHeight() - 34 );
	buttonDefault:SetText( "Default" );
	buttonDefault:SetSize( string.len(buttonDefault:GetText()) * 10, 15 ); --Auto size with text lenght
	buttonDefault:SetVisible( true );

	buttonDefault.Click = function(sender, args)
		SetToAll = SetToAllCtr:IsChecked();
		alphaScrollBar:SetValue( 30 );
		curSelAlpha = ( 0.3 );
		curSelRed = ( 0.3 );
		curSelGreen = ( 0.3 );
		curSelBlue = ( 0.3 );
		curSelColor:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) );
		ChangeColor();
		buttonSave:SetEnabled( true );
	end
	-- **^
	-- **v Black button v**
	local buttonBlack = Turbine.UI.Lotro.Button();
	buttonBlack:SetParent( wBackground );
	buttonBlack:SetPosition( buttonDefault:GetLeft() + buttonDefault:GetWidth() + 5, wBackground:GetHeight() - 34 );
	buttonBlack:SetText( "Black" );
	buttonBlack:SetSize( string.len(buttonBlack:GetText()) * 10, 15 ); --Auto size with text lenght
	buttonBlack:SetVisible( true );

	buttonBlack.Click = function(sender, args)
		SetToAll = SetToAllCtr:IsChecked();
		alphaScrollBar:SetValue ( 100 );
		curSelAlpha = ( 1 );
		curSelRed = ( 0 );
		curSelGreen = ( 0 );
		curSelBlue = ( 0 );
		curSelColor:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) );
		ChangeColor();
		buttonSave:SetEnabled( true );
	end
	-- **^
	-- **v Transparent button v**
	local buttonTrans = Turbine.UI.Lotro.Button();
	buttonTrans:SetParent( wBackground );
	buttonTrans:SetPosition( buttonBlack:GetLeft() + buttonBlack:GetWidth() + 5, wBackground:GetHeight() - 34 );
	buttonTrans:SetText( "Transparent" );
	buttonTrans:SetSize( string.len(buttonTrans:GetText()) * 10, 15 ); --Auto size with text lenght
	buttonTrans:SetVisible( true );

	buttonTrans.Click = function(sender, args)
		SetToAll = SetToAllCtr:IsChecked();
		alphaScrollBar:SetValue ( 0 );
		curSelAlpha = ( 0 );
		curSelRed = ( 0 );
		curSelGreen = ( 0 );
		curSelBlue = ( 0 );
		curSelColor:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) );
		ChangeColor();
		--wTitanBar:SetBackColor( Turbine.UI.Color( bcAlpha, curSelRed, curSelGreen, curSelBlue ) );
		buttonSave:SetEnabled( true );
	end
	-- **^
	-- Create Colour Picker window/border.
	ColourPickerBorder = Turbine.UI.Label();
	ColourPickerBorder:SetParent( wBackground );
	ColourPickerBorder:SetPosition( 40, 60 );
	ColourPickerBorder:SetSize( 242, 73 );
	ColourPickerBorder:SetBackColor( Turbine.UI.Color( 1, .2, .2, .2  ) );
	ColourPickerBorder:SetVisible( true );
	
	-- Create Colour Picker.
	ColourPicker = Turbine.UI.Label();
	ColourPicker:SetParent( ColourPickerBorder );
	ColourPicker:SetPosition( 1, 1 );
	ColourPicker:SetSize( 240, 71 ); 
	ColourPicker:SetBackground( "HabnaPlugins/HugeBag/Resources/picker.jpg" );

	ColourPicker.GetColorFromCoord = function( sender, X, Y )
		-- Controls the visibility of the cursor window
		local blockXvalue = (math.floor(ColourPicker:GetWidth()/3));
		local blockYvalue = (math.floor(ColourPicker:GetHeight()/2));

		curColor = Turbine.UI.Color();
		--curColor.A = 1.0;
		local myX=X
		local myY=Y
		local curRed = 0;
		local curGreen = 0;
		local curBlue = 0;

		if (myX >= 0) and (myX < blockXvalue) then

			-- First color block = red to green
			curRed = 100-((100/blockXvalue)*myX);
			curGreen = (100/blockXvalue)*myX;
			curBlue = 0;

		elseif (myX >= blockXvalue) and (myX < (2*blockXvalue)) then

			-- Second color block = green to blue
			curRed = 0;
			curGreen = 100-((100/blockXvalue)*(myX - blockXvalue));
			curBlue = (100/blockXvalue)*(myX - blockXvalue);

		elseif (myX >= (2*blockXvalue)) then

			-- Third color block = blue to red
			curRed = (100/blockXvalue)*(myX - 2*blockXvalue);
			curGreen = 0;
			curBlue = 100-((100/blockXvalue)*(myX - 2*blockXvalue));

		end

		if myY <= blockYvalue then

			-- In the top block, so fade from black to full color
			curRed = curRed * (myY/blockYvalue);
			curGreen = curGreen * (myY/blockYvalue);
			curBlue = curBlue * (myY/blockYvalue);

		else

			-- In the bottom block, so fade from full color to white
			curRed = curRed + ((myY - blockYvalue) * ((100 - curRed)/(blockYvalue)));
			curGreen = curGreen + ((myY - blockYvalue) * ((100 - curGreen)/(blockYvalue)));
			curBlue = curBlue + ((myY - blockYvalue) * ((100 - curBlue)/(blockYvalue)));

		end

		curColor.A = bcAlpha;
		curColor.R = (1/100) * curRed;
		curColor.G = (1/100) * curGreen;
		curColor.B = (1/100) * curBlue;
		return curColor;
	end

	ColourPicker.MouseMove = function( sender, args )
		mColor = ColourPicker:GetColorFromCoord( args.X, args.Y );

		if SetToAllCtr:IsChecked() then
			wTitanBar:SetBackColor( mColor );
			if ShowMoney then MoneyCtr:SetBackColor( mColor ); end
			if ShowDestinyPoints then DPCtr:SetBackColor( mColor ); end
			if ShowBagInfos then BagCtr:SetBackColor( mColor ); end
			if ShowPlayerInfos then PlayerCtr:SetBackColor( mColor ); end
			if ShowGameTime then GTCtr:SetBackColor( mColor ); end
		else
			if sFrom == nil then wTitanBar:SetBackColor( mColor ); end
			if sFrom == "Money" then MoneyCtr:SetBackColor( mColor ); end
			if sFrom == "DP" then DPCtr:SetBackColor( mColor ); end
			if sFrom == "BI" then BagCtr:SetBackColor( mColor ); end
			if sFrom == "PN" then PlayerCtr:SetBackColor( mColor ); end

			if sFrom == "GT" then GTCtr:SetBackColor( mColor ); end
			--wTitanBar:SetBackColor( mColor );
		end
	end
	
	ColourPicker.MouseClick = function( sender, args )
		curSelRed = curColor.R;
		curSelGreen = curColor.G;
		curSelBlue = curColor.B;
		curSelColor:SetBackColor( mColor );
		buttonSave:SetEnabled( true );
	end


	wBackground.Closing = function( sender, args )
		SetToAll = SetToAllCtr:IsChecked();

		if SetToAll then
			bcAlpha, MbcAlpha, DPbcAlpha, BbcAlpha, PIbcAlpha, GTbcAlpha = curSelAlpha, curSelAlpha, curSelAlpha, curSelAlpha, curSelAlpha, curSelAlpha;
			bcRed, MbcRed, DPbcRed, BbcRed, PIbcRed, GTbcRed = curSelRed, curSelRed, curSelRed, curSelRed, curSelRed, curSelRed;
			bcGreen, MbcGreen, DPbcGreen, BbcGreen, PIbcGreen, GTbcGreen = curSelGreen, curSelGreen, curSelGreen, curSelGreen, curSelGreen, curSelGreen;
			bcBlue, MbcBlue, DPbcBlue, BbcBlue, PIbcBlue, GTbcBlue = curSelBlue, curSelBlue, curSelBlue, curSelBlue, curSelBlue, curSelBlue;
		else
			if sFrom == nil then bcAlpha = curSelAlpha; bcRed = curSelRed; bcGreen = curSelGreen; bcBlue = curSelBlue; end
			if sFrom == "Money" then MbcAlpha = curSelAlpha; MbcRed = curSelRed; MbcGreen = curSelGreen; MbcBlue = curSelBlue; end
			if sFrom == "DP" then DPbcAlpha = curSelAlpha; DPbcRed = curSelRed; DPbcGreen = curSelGreen; DPbcBlue = curSelBlue; end
			if sFrom == "BI" then BbcAlpha = curSelAlpha; BbcRed = curSelRed; BbcGreen = curSelGreen; BbcBlue = curSelBlue; end
			if sFrom == "PN" then PIbcAlpha = curSelAlpha; PIbcRed = curSelRed; PIbcGreen = curSelGreen; PIbcBlue = curSelBlue; end

			if sFrom == "GT" then GTbcAlpha = curSelAlpha; GTbcRed = curSelRed; GTbcGreen = curSelGreen; GTbcBlue = curSelBlue; end
		end
				
		ChangeColor();
		frmBG = nil;
	end
end