-- menu.lua
-- Written By Habna


-- Locale menu
local LocMenu = Turbine.UI.MenuItem( L["MCL"] );
LocMenu.Items = LocMenu:GetItems();

local LocItems1 = Turbine.UI.MenuItem( L["MCLen"] );
LocItems1:SetChecked( false );	
if TBLocale == "en" then
	LocItems1:SetChecked( true );
	LocItems1.Click = function( sender, args )
		TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos);
	end
else
	LocItems1.Click = function( sender, args )
		TBLocale = "en";
		ChangeTitanBarLanguage();
	end
end
LocMenu.Items:Add( LocItems1 );

local LocItems2 = Turbine.UI.MenuItem( L["MCLfr"] );
LocItems2:SetChecked( false );
if TBLocale == "fr" then
	LocItems2:SetChecked( true );
	LocItems2.Click = function( sender, args )
		TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos);
	end
else
	LocItems2.Click = function( sender, args )
		TBLocale = "fr";
		ChangeTitanBarLanguage();
	end
end
LocMenu.Items:Add( LocItems2 );

LocItems3 = Turbine.UI.MenuItem( L["MCLde"] );
LocItems3:SetChecked( false );
if TBLocale == "de" then
	LocItems3:SetChecked( true );
	LocItems3.Click = function( sender, args )
		TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos);
	end
else
	LocItems3.Click = function( sender, args )
		TBLocale = "de";
		ChangeTitanBarLanguage();
	end
end
LocMenu.Items:Add( LocItems3 );

--- Main menu
TitanBarMenu = Turbine.UI.ContextMenu();
TitanBarMenu.items = TitanBarMenu:GetItems();

local opt_line = Turbine.UI.MenuItem("---------------------------------------------", false);
local opt_empty = Turbine.UI.MenuItem("", false);

local opt_Money = Turbine.UI.MenuItem(L["MBag"]);
opt_Money.Click = function( sender, args ) ShowHideMoney(); opt_Money:SetChecked( not opt_Money:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end
opt_Money:SetChecked( ShowMoney );

local opt_DP = Turbine.UI.MenuItem(L["MDP"]);
opt_DP.Click = function( sender, args ) ShowHideDestinyPoints(); opt_DP:SetChecked( not opt_DP:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end
opt_DP:SetChecked( ShowDestinyPoints );

local opt_BI = Turbine.UI.MenuItem(L["MBI"]);
opt_BI.Click = function( sender, args ) ShowHideBackpackInfos(); opt_BI:SetChecked( not opt_BI:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end
opt_BI:SetChecked( ShowBagInfos );

local opt_PI = Turbine.UI.MenuItem(L["MPI"]);
opt_PI.Click = function( sender, args ) ShowHidePlayerInfos(); opt_PI:SetChecked( not opt_PI:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end
opt_PI:SetChecked( ShowPlayerInfos );

local opt_GT = Turbine.UI.MenuItem(L["MGT"]);
opt_GT.Click = function( sender, args ) ShowHideGameTime(); opt_GT:SetChecked( not opt_GT:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end
opt_GT:SetChecked( ShowGameTime );

local opt_ResetAllSet = Turbine.UI.MenuItem(L["MRA"]);
opt_ResetAllSet.Click = function( sender, args ) ResetSettings(); end

local opt_unload = Turbine.UI.MenuItem(L["MUTB"] .. Version);
opt_unload.Click = function( sender, args ) UnloadTitanBar(); end

local opt_reload = Turbine.UI.MenuItem(L["MRTB"] .. Version);
opt_reload.Click = function( sender, args ) ReloadTitanBar(); end

local option_backcolor = Turbine.UI.MenuItem(L["MBG"]);
option_backcolor.Click = function( sender, args ) SetBackgroundColor(); end

--TitanBarMenu.items:Add(opt_Money);
--TitanBarMenu.items:Add(opt_DP);
TitanBarMenu.items:Add(opt_BI);
TitanBarMenu.items:Add(opt_PI);
TitanBarMenu.items:Add(opt_GT);
TitanBarMenu.items:Add(opt_line);
TitanBarMenu.items:Add(option_backcolor);
TitanBarMenu.items:Add(LocMenu);
TitanBarMenu.items:Add(opt_empty);
TitanBarMenu.items:Add(opt_ResetAllSet);
TitanBarMenu.items:Add(opt_empty);
TitanBarMenu.items:Add(opt_unload);
TitanBarMenu.items:Add(opt_reload);