-- functionsMenu.lua
-- Written By Habna


--**v Functions for the menu v**
--**v Unload TitanBar v**
function UnloadTitanBar()
	--write( "TitanBar: Unloaded" );
	Turbine.PluginManager.LoadPlugin( 'TitanBar Unloader' );
	--Turbine.PluginManager.UnloadScriptState( 'TitanBar' );
end
--**^
--**v Reload TitanBar v**
function ReloadTitanBar()
	--write( "TitanBar: Reloaded" );
	Turbine.PluginManager.LoadPlugin( 'TitanBar Reloader' );
	--UnloadTitanBar();
	--Turbine.PluginManager.LoadPlugin( 'TitanBar' );
end
--**^
-- **v Show/Hide Money v**
function ShowHideMoney()
	ShowMoney = not ShowMoney;
	SaveSettings();
	if ShowMoney then
		--write( "TitanBar: Showing money");
		wTitanBar.playerAtt = Player:GetAttributes();
		wTitanBar.moneyChangedHandler = AddCallback(wTitanBar.playerAtt, "MoneyChanged", function(sender, args) UpdateMoney(); end);
		import (AppDirD.."MoneyInfos");
		UpdateMoney();
	else
		--write( "TitanBar: Hiding money");
		RemoveCallback(wTitanBar.playerAtt, "MoneyChanged", wTitanBar.moneyChangedHandler);
	end
	MoneyCtr:SetVisible( ShowMoney );
	ReplaceModuleLocation();
end
-- **^
-- **v Show/Hide Destiny Points v**
function ShowHideDestinyPoints()
	ShowDestinyPoints = not ShowDestinyPoints;
	SaveSettings();
	if ShowDestinyPoints then
		--write( "TitanBar: Showing Destiny Points");
		wTitanBar.playerAtt = Player:GetAttributes();
		wTitanBar.dpChangedHandler = AddCallback(wTitanBar.playerAtt, "DestinyPointsChanged", function(sender, args) UpdateDestinyPoints(); end);
		import (AppDirD.."DestinyPoints");
		UpdateDestinyPoints();
	else
		--write( "TitanBar: Hiding Destiny Points");
		RemoveCallback(wTitanBar.playerAtt, "DestinyPointsChanged", wTitanBar.dpChangedHandler);
	end
	DPCtr:SetVisible( ShowDestinyPoints );
	ReplaceModuleLocation();
end
-- **^
-- **v Show/Hide Backpack Infos v**
function ShowHideBackpackInfos()
	ShowBagInfos = not ShowBagInfos;
	SaveSettings();
	if ShowBagInfos then
		--write( "TitanBar: Showing backpack infos");
		Backpack = Player:GetBackpack();
		wTitanBar.iaHandler = AddCallback(Backpack, "ItemAdded", function(sender, args) UpdateBackpackInfos(); end);
		wTitanBar.irHandler = AddCallback(Backpack, "ItemRemoved", function(sender, args) UpdateBackpackInfos(); end);
		import (AppDirD.."BagInfos");
		UpdateBackpackInfos();
	else
		--write( "TitanBar: Hiding backpack infos");
		RemoveCallback(Backpack, "ItemAdded", wTitanBar.iaHandler);
		RemoveCallback(Backpack, "ItemRemoved", wTitanBar.irHandler);
	end
	BagCtr:SetVisible( ShowBagInfos );
	ReplaceModuleLocation();
end
--**^
-- **v Show/Hide Backpack Infos v**
function ShowHidePlayerInfos()
	ShowPlayerInfos = not ShowPlayerInfos;
	SaveSettings();
	if ShowPlayerInfos then
		--write( "TitanBar: Showing player infos");
		wTitanBar.levelChangedHandler = AddCallback(Player, "LevelChanged", function(sender, args) PlayerLvl:SetText( Player:GetLevel() ); end);
		wTitanBar.nameChangedHandler = AddCallback(Player, "NameChanged", function(sender, args) PlayerName:SetText( Player:GetName() ); end);
		import (AppDirD.."PlayerInfos");
		UpdatePlayersInfos();
	else
		--write( "TitanBar: Hiding player infos");
		RemoveCallback(Player, "LevelChanged", wTitanBar.levelChangedHandler);
		RemoveCallback(Player, "NameChanged", wTitanBar.nameChangedHandler);
	end
	PlayerCtr:SetVisible( ShowPlayerInfos );
	ReplaceModuleLocation();
end
--**^
-- **v Show/Hide Time v**
function ShowHideGameTime()
	ShowGameTime = not ShowGameTime;
	SaveSettings();
	if ShowGameTime then
		--write( "TitanBar: Showing time");
		--wTitanBar.levelChangedHandler = AddCallback(wTitanBar.player, "TimeChanged", function(sender, args) UpdatePlayersInfos(); end);
		import (AppDirD.."GameTime");
		UpdateGameTime();
		GTTimer:SetWantsUpdates( true );
	else
		--write( "TitanBar: Hiding time");
		--RemoveCallback(wTitanBar.player, "TimeChanged", wTitanBar.levelChangedHandler);
		GTTimer:SetWantsUpdates( false );
	end
	GTCtr:SetVisible( ShowGameTime );
	ReplaceModuleLocation();
end
--**^